Imports System.Data
Imports System.Data.OleDb
Imports System.web.Mail

Imports SendMail
Imports General

Partial Class Admin
    Inherits System.Web.UI.Page

    Dim objCon As OleDbConnection
    Dim objPwdCon As OleDbConnection
    Dim objMail As OleDbConnection
    Dim adp As New OleDbDataAdapter

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Session("CoCode") = String.Empty Then
                Response.Redirect("Login.aspx")
            ElseIf StrComp(Session("EmpId"), "Admin") <> 0 Then
                Response.Redirect("EmpLogin.aspx")
            End If

            objCon = New OleDbConnection(Session("myConnection"))
            objPwdCon = New OleDbConnection(Session("PwdConnection"))

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub btnProceed_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSend.Click
        Try
            Dim objReader As OleDbDataReader
            If txtEmpCode.Text = "" Then
                lblMsg.Text = "Please Enter Employee Code"
                Exit Sub
            ElseIf InStr(txtEmpCode.Text, "'", CompareMethod.Binary) > 0 Then
                lblMsg.Text = "The Employee Code does not exists"
                Exit Sub
            ElseIf txtNewPass.Text = "" Then
                lblMsg.Text = "Please Enter or Generate Password"
                Exit Sub
            ElseIf txtNewPass.Text.Length < 6 Then
                lblMsg.Text = "Password should be atleast 6 characters in length"
                Exit Sub
            End If

            Dim EmpMailID As String
            Dim strEmpName As String
            Dim oleDBcmd As New OleDbCommand("Select EmpCode,EmpName from EmpMaster where EmpCode ='" & Replace(txtEmpCode.Text, "'", "") & "'", objCon)
            Dim Dr As OleDbDataReader

            objPwdCon.Open()
            objCon.Open()

            Dr = oleDBcmd.ExecuteReader
            If Dr.HasRows = False Then
                lblMsg.Text = "Employee not present in Database"
                Exit Sub
            Else
                Dr.Read()
                lblMsg.Text = String.Empty
                strEmpName = Dr("EmpName")
            End If
            Dr.Close()


            Dim oleDBcmdPwd As New OleDbCommand("Select Count(EmpCode) from Employee where EmpCode ='" & Replace(txtEmpCode.Text, "'", "") & "'", objPwdCon)


            If oleDBcmdPwd.ExecuteScalar = 0 Then
                'Ver 4.1 QC1148 start
                ' oleDBcmdPwd.CommandText = "Insert into Employee (EmpCode,PWD) values ('" & txtEmpCode.Text.Trim & "','" & txtNewPass.Text & "')"
                oleDBcmdPwd.CommandText = "Insert into Employee (EmpCode,PWD) values (@EmpCode,@NewPass)"
                oleDBcmdPwd.Parameters.AddWithValue("@EmpCode", txtEmpCode.Text.Trim)
                oleDBcmdPwd.Parameters.AddWithValue("@NewPass", txtNewPass.Text)
                'Ver 4.1 QC1148 end 
                oleDBcmdPwd.ExecuteNonQuery()
            Else
                'Ver 4.1 QC1148 start
                ' oleDBcmdPwd.CommandText = "Update Employee set PWD ='" & txtNewPass.Text & "' where EmpCode ='" & txtEmpCode.Text & "'"
                oleDBcmdPwd.CommandText = "Update Employee set PWD =@NewPass where EmpCode =@EmpCode"
                oleDBcmdPwd.Parameters.AddWithValue("@NewPass", txtNewPass.Text)
                oleDBcmdPwd.Parameters.AddWithValue("@EmpCode", txtEmpCode.Text)

                'Ver 4.1 QC1148 end 
                oleDBcmdPwd.ExecuteNonQuery()
            End If


            EmpMailID = GetEmail(Session("myconnection"), txtEmpCode.Text)

            Dim sb As New StringBuilder
            sb = sb.Append("Hello " & strEmpName & ",<br /><br />" & _
                        "Your password for this account has recently been changed by the Administrator." & _
                        " You don't need to do anything, this message is simply a notification " & _
                        "to protect the security of your account." & "<br /><br />" & _
                        "Details of password are as follows :" & "<br /><br />" & _
                        "Company Name :" & Session("CoName") & "<br />" & _
                        "Employee Code :" & UCase(txtEmpCode.Text) & "<br />" & _
                        "New Password :" & txtNewPass.Text & "<br /><br />" & _
                        "Regards <br />Administrator.")

            '--Connecting to the Emails.mdb
            objMail = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;data source=" & Server.MapPath(".") & "\Emails.mdb;jet OLEDB:Database Password=Ffcs")
            objMail.Open()

            adp = New OleDbDataAdapter("select * from Emails where CompanyCode='" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "'", objMail)
            objReader = adp.SelectCommand.ExecuteReader()

            If objReader.HasRows Then objReader.Read()
            If objReader.HasRows Then
                '--Call Mailer(System.Configuration.ConfigurationManager.AppSettings("AdminEID"), System.Configuration.ConfigurationManager.AppSettings("AdminEID"), "New Password", sb.ToString, "localhost", , EmpMailID)
                '==>jitendra
                'Call Mailer(objReader("AdminEmail"), objReader("AdminEmail"), "New Password", sb.ToString, "localhost", , EmpMailID)
                Dim sAdminMailID As String
                sAdminMailID = objReader("AdminEmail") & "," & EmpMailID
                Call Mailer(sAdminMailID, objReader("AdminEmail"), "New Password", sb.ToString, "localhost", objReader("BCCEmail"), objReader("CCEMail"))
                '<==Jitendra
                If funSendMail() = True Then
                    If EmpMailID = String.Empty Or EmpMailID.Trim() = "" Then
                        lblMsg.Text = "Password sent Successfully to Admin Only,Email Id is not available for this Employee"
                    Else
                        lblMsg.Text = "Password sent Successfully to Admin and " & strEmpName
                    End If
                Else
                    lblMsg.Text = "Error while sending mail."
                End If
            Else
                lblMsg.Text = "Admin Email Id Not Found!"
                Exit Sub
            End If
            txtNewPass.Text = String.Empty
            txtEmpCode.Text = String.Empty
            objMail.Close()
            objMail = Nothing

            objCon.Close()
            objPwdCon.Close()
        Catch ex As Exception
            lblMsg.Text = ex.Message
        End Try
    End Sub

    Private Function RandomPassword() As String
        Dim arrPossibleChars As Char() = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789".ToCharArray()
        Dim intPasswordLength As Integer = 6
        Dim stringPassword As String = Nothing
        Dim rand As System.Random = New Random
        Dim i As Integer = 0
        For i = 0 To intPasswordLength
            Dim intRandom As Integer = rand.Next(arrPossibleChars.Length)
            stringPassword = stringPassword & arrPossibleChars(intRandom).ToString()
        Next
        RandomPassword = stringPassword
    End Function

    Protected Sub btnGeneratePWD_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnGeneratePWD.Click
        txtNewPass.Text = RandomPassword()
    End Sub

End Class

