﻿Imports System.Globalization
Imports System.Xml
Imports System.Xml.XPath
Imports MigraDoc.DocumentObjectModel
Imports MigraDoc.DocumentObjectModel.Tables
Imports MigraDoc.DocumentObjectModel.Shapes
Imports MigraDoc.Rendering
Imports System.Diagnostics
Imports System.Data
Public Class PDFform
    Private document As Document
    Public dt As DataSet
    Private path As String
    Private section As Section
    Private addressFrame As TextFrame
    Private table As Table
    Private dHeight As String
    Private dWidth As String
    Private ColWidth As String
    Private ColAlign As String
    Private ShowRsSymbol As String = ""


    Public Sub New()
    End Sub
    Public Sub New(ByVal myds As DataSet, ByVal docHeight As String, ByVal docWidth As String)
        dt = myds
        dHeight = docHeight
        dWidth = docWidth
    End Sub
    Public Function CreateDocument() As Document
        ' Create a new MigraDoc document
        Me.document = New Document()

        Me.document.Info.Title = ""
        Me.document.Info.Subject = ""
        Me.document.Info.Author = "TR"
        CreatePage()
        If HttpContext.Current.Session("PageName") = "Home" Then
            FillHome()
            'Ver 4.3 FASTFACTS-617 start
            ' ElseIf HttpContext.Current.Session("PageName") = "PaySlip" Then
        ElseIf HttpContext.Current.Session("PageName") = "PaySlip" Or HttpContext.Current.Session("PageName") = "Payslip with Rate" Then
            'FillContentPayslip()
            FillContentPayslip(HttpContext.Current.Session("PageName"))
            'Ver 4.3 FASTFACTS-617 end 
        ElseIf HttpContext.Current.Session("PageName") = "Estimation Slip" Then
            FillContent()
        ElseIf HttpContext.Current.Session("PageName") = "Company Loan Details" Then
            FillLoan()
        ElseIf HttpContext.Current.Session("PageName") = "Annual Salary Report" Then
            FillContentAnnualSalary()
        ElseIf HttpContext.Current.Session("PageName") = "Leaves Details" Then
            FillContent()
        ElseIf HttpContext.Current.Session("PageName") = "Reimbursement Details" Then
            FillReimbursment()
        ElseIf HttpContext.Current.Session("PageName") = "Investment Declaration" Then
            FillInvestmentDeclaration()
        ElseIf HttpContext.Current.Session("PageName") = "Proof Submission" Then
            FillInvestmentProof()
        Else
            Alert.Show("Not Required.")
        End If

        Return Me.document
    End Function

    Private Sub CreatePage()
        document.DefaultPageSetup.PageFormat = PageFormat.P11x17

        'document.DefaultPageSetup.PageHeight = "20.0in"
        document.DefaultPageSetup.PageWidth = dWidth
        section = document.AddSection()

        Dim image As Image = section.AddImage(HttpContext.Current.Server.MapPath("IMAGES") & "/" & HttpContext.Current.Session("CoCode") & Mid(HttpContext.Current.Session("Period"), 3, 2) & "/Paypac.bmp")
        image.Top = ShapePosition.Top
        image.Left = ShapePosition.Left
        image.WrapFormat.Style = WrapStyle.Through

        Dim paragraph As Paragraph = section.AddParagraph()

        paragraph.AddLineBreak()
        paragraph.AddLineBreak()
        paragraph.AddLineBreak()
        paragraph.AddLineBreak()
        paragraph.AddLineBreak()
        paragraph.AddLineBreak()
        paragraph.AddLineBreak()
        paragraph.AddLineBreak()

        Dim f As FormattedText = paragraph.AddFormattedText(HttpContext.Current.Session("CoName").ToString())
        f.Font.Size = 9
        f.Font.Bold = True
        paragraph.AddLineBreak()
        ' paragraph.AddLineBreak()
        ' paragraph.AddLineBreak()
        Dim title = HttpContext.Current.Session("PageName")
        ' FASTFACTS-675 start
        'If title = "PaySlip" Then
        If title = "PaySlip" Or title = "Payslip with Rate" Then
            ' FASTFACTS-675 end 
            'Ver 4.0-QC972 start
            If (General.GetData(HttpContext.Current.Session("PgRightsConn").ToString(), "select allowtouser from pagerights where pagename='Print Address on PaySlip'")) = True Then
                '==>Jitendra 14/07/2015
                Dim compText As FormattedText = paragraph.AddFormattedText(HttpContext.Current.Session("companyTxt").ToString)
                compText.Font.Size = 9
                compText.Font.Bold = False
                paragraph.AddLineBreak()
                paragraph.AddLineBreak()
                paragraph.AddLineBreak()
                '<==Jitendra 14/07/2015
            End If
            'Ver 4.0-QC972 end 

            paragraph.AddText("Payslip for the Month of " & MonthName(Right(HttpContext.Current.Session("CMonth"), 2)) _
                                               & " " & Left(HttpContext.Current.Session("CMonth"), 4))
            paragraph.AddLineBreak()
        ElseIf title = "Leaves Details" Then
            paragraph.AddText("Leave details for the Month of " & MonthName(Right(HttpContext.Current.Session("CMonth"), 2)) _
             & " " & Left(HttpContext.Current.Session("CMonth"), 4))

            'paragraph.AddText("Leave details for the Month of " & MonthName(Right(HttpContext.Current.Session("CMonth"), 2)) _
            ' & " " & Left(HttpContext.Current.Session("CMonth"), 4) & "      " & HttpContext.Current.Session("Period") & " " & HttpContext.Current.Session("EmpName"))  ''kishor added - 03-09-2020
            'paragraph.AddText(HttpContext.Current.Session("Period")) ''kishor added - 03-09-2020
            'paragraph.AddText(HttpContext.Current.Session("EmpName")) ''kishor added - 03-09-2020

            paragraph.AddLineBreak()

            ''kishor added - 02-09-2020 - to resolve issue - Download PDF to appear emplyee details
            paragraph.AddText(HttpContext.Current.Session("Period"))
            paragraph.AddTab()
            paragraph.AddTab()
            paragraph.AddText(HttpContext.Current.Session("EmpName"))
            ''kishor added - 02-09-2020
        Else

            If Not HttpContext.Current.Session("PageName").ToString().Trim().ToLower() = "home" Then
                paragraph.AddText(HttpContext.Current.Session("PageName"))
                paragraph.AddLineBreak()
            End If


            paragraph.AddText(HttpContext.Current.Session("Period"))
            paragraph.AddTab()
            paragraph.AddTab()
            paragraph.AddText(HttpContext.Current.Session("EmpName"))


        End If
        If (title = "Proof Submission") Then




            section = document.LastSection
            section.PageSetup = document.DefaultPageSetup.Clone()
            section.PageSetup.StartingNumber = 1

            section.Footers.Primary = New HeaderFooter()
            Dim para As Paragraph = section.Footers.Primary.AddParagraph()
            para.Format.Alignment = ParagraphAlignment.Right
            para.AddText("Page ")
            para.AddPageField()
            para.AddText(" of ")
            para.AddNumPagesField()
            'Dim sec2 = document.AddSection()
            'sec2.PageSetup = document.DefaultPageSetup.Clone()



            '    Me.table = section.Headers.Primary.AddTable()
            '    Dim row As Row
            '    table.AddColumn(Unit.FromInch(7.5))

            '    row = Me.table.AddRow()
            '    row.HeadingFormat = True
            '    table.TopPadding = "0.9cm"
            '    table.Columns.Width = dWidth
            '    Dim pp As Paragraph = row.Cells(0).AddParagraph()
            '    Dim ff As FormattedText = pp.AddFormattedText("EMP CODE : " + Convert.ToString(dt.Tables(1).Rows(0)("EmpCode")))
            '    pp.Format.Alignment = ParagraphAlignment.Right
            '    pp.Format.Font.Bold = True
            '    pp.Format.Font.Size = 8
            '    pp.Format.Font.Name = "Verdana"
            '    row.Cells(0).Format.Alignment = ParagraphAlignment.Right

        End If
    End Sub
    'Ver 4.3 FASTFACTS-617 start
    'Private Sub FillContentPayslip()
    Private Sub FillContentPayslip(ByRef title As String)
        Dim dbVal As Double = 0
        If title = "PaySlip" Then
            ShowRsSymbol = "Amount,DAmount"
        Else
            ShowRsSymbol = "Rate,Amount,DAmount"
        End If
        'Ver 4.3 FASTFACTS-617 end 
        Dim prln As Paragraph = section.AddParagraph()
        prln.AddText("  ______________________________________________________________________________________________________")
        prln.Format.Font.Size = 7
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Left
        prln.AddLineBreak()

        Dim tmddt As DataTable = dt.Tables(0)
        tmddt.Columns.RemoveAt(1)
        tmddt.Columns.RemoveAt(3)
        ColWidth = "3,5,3,5"
        ColAlign = "0,0,0,0"
        FillTable(tmddt, False)
        addline("0.2cm", "0.3cm")
        tmddt = dt.Tables(1)
        'Ver 4.3 FASTFACTS-617 start
        ' tmddt.Columns.RemoveAt(2)
        If title = "PaySlip" Then
            tmddt.Columns.RemoveAt(2)
            ColWidth = "5,3,5,3"
            ColAlign = "0,2,0,2"
        Else
            ColWidth = "3,3,3,4,3"
            ColAlign = "0,2,2,0,2"
        End If
        'tmddt.Columns(1).ColumnName = "Amount"
        'FillTable(tmddt, True)
        If title = "PaySlip" Then
            tmddt.Columns(1).ColumnName = "Amount"
            FillTable(tmddt, True)
        Else

            tmddt.Columns(1).ColumnName = "Rate"
            tmddt.Columns(2).ColumnName = "Amount"
            'Dim dbVal As Double = 0
            For index = 0 To tmddt.Rows.Count - 1
                If tmddt.Rows(index)("Rate").ToString = String.Empty Then
                    dbVal = 0
                Else
                    dbVal = Convert.ToDouble(tmddt.Rows(index)("Rate"))
                End If

            Next
            If dbVal = 0 Then
                tmddt.Columns.RemoveAt(1)
                ColWidth = "5,3,5,3"
                ColAlign = "0,2,0,2"
            End If


            FillTable(tmddt, True)
        End If

        'Ver 4.3 FASTFACTS-617 end 
        addline("0.2cm", "0.3cm")
        tmddt = dt.Tables(2)
        'Ver 4.3 FASTFACTS-617 start
        'tmddt.Columns.RemoveAt(2)
        If title = "PaySlip" Then
            tmddt.Columns.RemoveAt(2)
        Else
            If dbVal = 0 Then
                tmddt.Columns.RemoveAt(1)
                ColWidth = "5,3,5,3"
                ColAlign = "0,2,0,2"
            End If
        End If
        'Ver 4.3 FASTFACTS-617  end 
        FillTable(tmddt, False)
        addline("0.2cm", "0.2cm")
        Dim t As New TextFrame()
        t.Width = "50.0cm"
        Dim pp As Paragraph = t.AddParagraph()
        pp.Format.Font.Size = 7
        pp.Format.Font.Name = "Verdana"
        pp.Format.Font.Bold = True
        ''pp.AddText("Amount Payable :") ''-- commented by kishor on - 27-02-2020
        pp.AddText("Net Amount :") ''-- added by kishor On - 27-02-2020
        pp.AddImage(HttpContext.Current.Server.MapPath("IMAGES") & "\rs.png")
        pp.Format.Font.Bold = False

        pp.AddText("                   " & Convert.ToDecimal(dt.Tables("NetAmounts").Rows(0).Item("'Net Amount'").ToString()).ToString("#,##0.00"))
        pp.AddLineBreak()

        ''-- commented by kishor on - 27-02-2020
        ''pp.AddText("Amount Payable in words :  " & General.ToTitleCase("" & General.GetNumsInWords(dt.Tables("NetAmounts").Rows(0).Item("'Net Amount'").ToString & "")))
        ''-- commented by kishor on - 27-02-2020

        ''-- added by kishor On - 27-02-2020
        pp.AddText("Net Pay in words :  " & General.ToTitleCase("" & General.GetNumsInWords(dt.Tables("NetAmounts").Rows(0).Item("'Net Amount'").ToString & "")))
        ''-- added by kishor On - 27-02-2020

        pp.AddLineBreak()
        If dt.Tables.Contains("CommonMessage") Then
            pp.AddLineBreak()
            pp.AddText("Message:")
            pp.AddLineBreak()
            pp.AddText(dt.Tables("CommonMessage").Rows(0)(0).ToString().Replace("<br/>", ""))
        End If

        Me.table.Section.Add(t)
    End Sub
    Private Sub FillContent()
        Dim prln As Paragraph = section.AddParagraph()
        prln.AddText("  ______________________________________________________________________________________________")
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Left
        prln.AddLineBreak()

        ColWidth = "7,2,2,2,2,2"
        ColAlign = "0,2,2,2,2,2"
        Dim tmddt As DataTable = dt.Tables(0)
        FillTable(tmddt, True)
        addline("0.2cm", "0.3cm")
    End Sub
    Private Sub FillContentAnnualSalary()
        ShowRsSymbol = "Amount"
        Dim prln As Paragraph = section.AddParagraph()
        prln.AddText("  ___________________________________________________________________________________________________________________________________________________________________________________")
        prln.AddLineBreak()
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Left
        prln.AddLineBreak()


        Dim tmddt As DataTable = dt.Tables(0)
        ColWidth = "4,2,2,2,2,2,2,2,2,2,2,2,2,4"
        ColAlign = "0,2,2,2,2,2,2,2,2,2,2,2,2,2"
        FillTable(tmddt, True)
        addline(17)
    End Sub
    Private Sub FillLoan()
        Dim prln As Paragraph = section.AddParagraph()
        prln.AddText("  ________________________________________________________________________________________________")
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Left
        ColWidth = "4,4,4,4"
        ColAlign = "0,0,0,0"
        FillTable(dt.Tables(0), False)
        Dim t As New TextFrame()
        t.Height = "0.4cm"
        Me.table.Section.Add(t)
        ColWidth = "2.5,2,2,3.5,3.5,3.5"
        ColAlign = "0,2,2,2,2,2"
        FillTable(dt.Tables(1), True)
    End Sub
    Private Sub FillReimbursment()
        Dim prln As Paragraph = section.AddParagraph()
        prln.AddText("  ________________________________________________________________________________________________________________")
        prln.AddLineBreak()
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Left
        prln.AddLineBreak()
        ColWidth = "4,4,4,4,4,4"
        ColAlign = "0,2,2,2,2,2"
        FillTable(dt.Tables(0), True)
    End Sub
    Private Sub FillInvestmentDeclaration()
        Dim prln As Paragraph = section.AddParagraph()


        prln.AddText("  ___________________________________________________________________________________________________________")
        prln.AddLineBreak()
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Left
        prln.AddLineBreak()
        Dim p As TextFrame = section.AddTextFrame()
        p.Width = Unit.FromCentimeter(16)
        p.Height = Unit.FromCentimeter(0.5)
        Dim x As Paragraph = p.AddParagraph("PLEASE READ THE NOTES BEFORE FILLING UP THIS FORM")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7

        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Center
        x.Format.Font.Bold = True
        prln = section.AddParagraph()
        prln.Format.Font.Size = 7
        prln.AddText("1.Provident Fund and Life Insurance Premium deductions through salary should not be shown in this form.")
        prln.AddLineBreak()
        'Ver 3.7-QC896 start
        'prln.AddText("2.Amount paid / payable during the year April 2010 - March 2011 should be shown under 'Amount' column.")
        prln.AddText("2.Amount paid / payable during the year April " & Mid(HttpContext.Current.Session("Period"), 1, 4) & " - March " & Mid(HttpContext.Current.Session("Period"), 6, 4) & " should be shown under 'Amount' column.")
        'Ver 3.7-QC896 end 
        prln.AddLineBreak()
        prln.AddText("3.If you have not yet applied for PAN, Please Apply for the same immediately. In case Valid PAN is not available, TDS will be ")
        prln.AddLineBreak()
        prln.AddText("deducted @30.9% (as per new Section 206AA) ")
        prln.AddLineBreak()
        prln.AddLineBreak()
        p = prln.Section.AddTextFrame()
        p.Height = Unit.FromCentimeter(0.5)
        p.Width = Unit.FromCentimeter(16)

        'Ver 3.5-REQ305 start
        'x = p.AddParagraph("INVESTMENT DECLARATION FORM FOR THE FY 2012-2013 ")  'HttpContext.Current.Session("Period")
        'Ver 3.7-QC896 start
        ' x = p.AddParagraph("INVESTMENT DECLARATION FORM FOR THE FY 2013-2014 ")
        x = p.AddParagraph("INVESTMENT DECLARATION FORM FOR THE FY " & HttpContext.Current.Session("Period"))
        'Ver 3.7-QC896 end 
        'Ver 3.5-REQ305 end
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Center
        x.Format.Font.Bold = True
        prln = section.AddParagraph()
        prln.Format.Font.Size = 7
        prln.AddLineBreak()
        prln.AddText("Employee ID : " & dt.Tables(3).Rows(0)(0).ToString())
        prln.AddLineBreak()
        prln.AddText("Employee Name : " & dt.Tables(3).Rows(1)(0).ToString())
        prln.AddLineBreak()
        prln.AddText("PAN : " & dt.Tables(3).Rows(2)(0).ToString())
        prln.AddLineBreak()
        prln.AddLineBreak()
        prln.AddText("I here by declare that my Investment plan for the current financial year is as follows: ")
        prln.AddLineBreak()
        prln.AddText("Investments proposal under Section 80 C:")
        prln.AddLineBreak()
        prln.AddLineBreak()
        ColWidth = "1,6,2,6"
        ColAlign = "0,0,2,0"
        FillTable(dt.Tables(0), True)
        ColWidth = "1,2,6,2,4"
        ColAlign = "0,0,0,2,0"
        FillTable(dt.Tables(1), True)
        addline(0)
        p = section.AddTextFrame()
        p.Height = Unit.FromCentimeter(1)
        p.Width = Unit.FromCentimeter(16)
        x = p.AddParagraph("HOUSE RENT DETAILS")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Center
        x.Format.Font.Bold = True

        ColWidth = "2,2,2"
        ColAlign = "0,2,0"
        FillTable(dt.Tables(2), True)
        addline(0)
        'Ver 4.1-REQ623 start
        p = section.AddTextFrame()
        p.Height = Unit.FromCentimeter(1)
        p.Width = Unit.FromCentimeter(16)
        x = p.AddParagraph("Landlord Information")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Center
        x.Format.Font.Bold = True
        ColWidth = "4,6"
        ColAlign = "0,2"
        FillTable(dt.Tables(4), False)
        addline(0)
        'Ver 4.1-REQ623 end 

        p = section.AddTextFrame()
        p.Height = Unit.FromCentimeter(1)
        p.Width = Unit.FromCentimeter(16)
        x = p.AddParagraph("INCOME FROM HOUSE PROPERTY ")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Center
        x.Format.Font.Bold = True

        'Ver 4.1-REQ623 start '12BB
        p = section.AddTextFrame()
        p.Height = Unit.FromCentimeter(1)
        p.Width = Unit.FromCentimeter(16)
        x = p.AddParagraph("a.Income from Self-occupied Property")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Left
        x.Format.Font.Bold = True

        prln = section.AddParagraph()
        prln.Format.Font.Size = 7

        prln.AddText("  Interest Paid/Payable on Housing Loan")
        prln.Format.Font.Bold = True
        prln.AddLineBreak()
        ColWidth = "6,6"
        ColAlign = "1,2"
        FillTable(dt.Tables(5), False)
        addline(0)

        p = section.AddTextFrame()
        p.Height = Unit.FromCentimeter(1)
        p.Width = Unit.FromCentimeter(16)
        x = p.AddParagraph("b.Income from Let-out Property")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Left
        x.Format.Font.Bold = True
        ColWidth = "6,6"
        ColAlign = "0,2"
        FillTable(dt.Tables(6), False)
        addline(0)

        

        p = section.AddTextFrame()
        p.Height = Unit.FromCentimeter(1)
        p.Width = Unit.FromCentimeter(16)
        x = p.AddParagraph("Lender Information")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Left
        x.Format.Font.Bold = True
        ColWidth = "6,6"
        ColAlign = "0,2"
        FillTable(dt.Tables(7), False)
        addline(0)

        'Ver 4.1-REQ623 end ' 12BB
        prln = section.AddParagraph()
        prln.Format.Font.Size = 7
        prln.AddText("1.Income from House Property- Amt of Interest paid: " & dt.Tables(3).Rows(3)(0).ToString() & " Certificate from Lender along with Form 12 C")
        prln.AddLineBreak()
        prln.AddLineBreak()
        prln.AddText("DECLARATION: ")
        prln.AddLineBreak()
        prln.AddText("I hereby declare the information given above is true & correct. I undertake to inform immediately of any change in the above facts.")
        prln.AddLineBreak()
        prln.AddText("Any Income tax liability arising out of wrong declaration will be my responsibility. ")
        prln.AddLineBreak()
        prln.AddLineBreak()
        prln.AddText("Date:" & Date.Now.ToString("dd/MM/yyyy"))
    End Sub
    Private Sub FillHome()
        ShowRsSymbol = "-"
        Dim prln As Paragraph = section.AddParagraph()
        prln.AddText("  ______________________________________________________________________________________________")
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Left
        prln.AddLineBreak()


        Dim p As TextFrame = section.AddTextFrame()
        p.Height = Unit.FromCentimeter(1)
        p.Width = Unit.FromCentimeter(16)
        Dim x As Paragraph = p.AddParagraph("Employee Details")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Center
        x.Format.Font.Bold = True
        ColWidth = "4,4,4,4"
        ColAlign = "0,0,0,0"
        FillTable(dt.Tables(0), False)
        ColWidth = "4,4,4,4"
        Dim t As New TextFrame()
        t.Height = "0.5cm"
        Me.table.Section.Add(t)
        p = section.AddTextFrame()
        p.Height = Unit.FromCentimeter(1)
        p.Width = Unit.FromCentimeter(16)
        x = p.AddParagraph("Employee UDF Details")
        x.Format.Shading.Color = Colors.Gray
        x.Format.Font.Size = 7
        x.Format.Font.Color = Colors.White
        x.Format.Alignment = ParagraphAlignment.Center
        x.Format.Font.Bold = True
        dt.Tables(1).Merge(dt.Tables(2))
        FillTable(dt.Tables(1), True)

    End Sub
    Private Sub FillInvestmentProof()


        Dim px3 As TextFrame = section.AddTextFrame()
        px3.Width = Unit.FromCentimeter(16)
        px3.Height = Unit.FromCentimeter(0.5)
        Dim xx3 As Paragraph = px3.AddParagraph("                           EMP CODE : " + Convert.ToString(dt.Tables(1).Rows(0)("EmpCode")))
        xx3.Format.Font.Name = "Verdana"
        xx3.Format.Font.Size = 8
        xx3.Format.Alignment = ParagraphAlignment.Right
        xx3.Format.Font.Bold = True



        Dim px As TextFrame = section.AddTextFrame()
        px.Width = Unit.FromCentimeter(15)
        px.Height = Unit.FromCentimeter(0.5)
        Dim xx As Paragraph = px.AddParagraph("FORM NO.12BB")
        xx.Format.Font.Name = "Verdana"
        xx.Format.Font.Size = 8
        xx.Format.Alignment = ParagraphAlignment.Center
        xx.Format.Font.Bold = True


        Dim px1 As TextFrame = section.AddTextFrame()
        px1.Width = Unit.FromCentimeter(15)
        px1.Height = Unit.FromCentimeter(0.5)
        Dim xx1 As Paragraph = px1.AddParagraph("(See rule 26C)")
        xx1.Format.Font.Name = "Verdana"
        xx1.Format.Font.Size = 8
        xx1.Format.Alignment = ParagraphAlignment.Center
        xx1.Format.Font.Bold = True

        Dim px2 As TextFrame = section.AddTextFrame()
        px2.Width = Unit.FromCentimeter(16)
        px2.Height = Unit.FromCentimeter(0.5)
        Dim xx2 As Paragraph = px2.AddParagraph("Statement showing particulars of claims by an employee for deduction of tax under section 192")
        xx2.Format.Font.Name = "Verdana"
        xx2.Format.Font.Size = 8
        xx2.Format.Alignment = ParagraphAlignment.Center
        xx2.Format.Font.Bold = True


        Dim prln As Paragraph = section.AddParagraph()
        'Emp
        ColWidth = "8, 8"
        ColAlign = "0, 0"
        FillTableInvestmentProof(dt.Tables("Employee"), False)
        ' prln.AddLineBreak()
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Center
        prln.AddLineBreak()
        prln.AddLineBreak()



        Dim p As TextFrame = section.AddTextFrame()
        p.Width = Unit.FromCentimeter(15)
        p.Height = Unit.FromCentimeter(0.5)
        prln.AddLineBreak()
        Dim x As Paragraph = p.AddParagraph("Details  of claims and evidence thereof ")
        x.Format.Alignment = ParagraphAlignment.Center
        x.Format.Font.Size = 8
        x.Format.Font.Bold = True


        'HRA
        ColWidth = "2,6,5,3"
        ColAlign = "0,0,0,0"
        FillTableInvestmentProof(dt.Tables(3), True)

        'LTA
        ColWidth = "2,6,5,3"
        ColAlign = "0,0,0,0"
        FillTableInvestmentProof(dt.Tables(4), True)

        'IFHP
        ColWidth = "2,6,5,3"
        ColAlign = "0,0,0,0"
        FillTableInvestmentProof(dt.Tables(5), True)
        prln.AddLineBreak()


        'ChIVA
        ColWidth = "2,6,5,3"
        ColAlign = "0,0,0,0"
        FillTableInvestmentProof(dt.Tables(6), True)

        'ChIVA-Other
        ColWidth = "2,6,5,3"
        ColAlign = "0,0,0,0"
        FillTableInvestmentProof(dt.Tables(7), True)


        'Ver 4.1-REQ623 end ' 12BB
        prln = section.AddParagraph()
        prln.Format.Font.Size = 7
        prln.AddLineBreak()
        prln.AddText("Verification")
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Center
        prln.Format.Font.Bold = True
        prln.Format.Font.Underline = Underline.Single

        prln = section.AddParagraph()
        prln.AddLineBreak()
        If (Convert.ToString(dt.Tables("Master").Rows(0)("FHName")).Equals(String.Empty)) Then
            prln.AddText("I, " + Convert.ToString(dt.Tables("Master").Rows(0)("EmpName")) + ", son/daughter of  " + "_____________________  do hereby certify the  information given above is complete and correct")
            prln = section.AddParagraph
        Else

            prln.AddText("I, " + Convert.ToString(dt.Tables("Master").Rows(0)("EmpName")) + ", son/daughter of  " + Convert.ToString(dt.Tables("Master").Rows(0)("FHName")) + " do hereby certify the  information given above is complete and correct")
            prln = section.AddParagraph
        End If

        prln.Format.Font.Size = 7
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Left

        prln.AddLineBreak()
        ColWidth = "2,7,7"
        ColAlign = "0,0,0"
        FillTableInvestmentProof(dt.Tables("Footer"), False)
        prln.Format.Font.Size = 8
        prln.Format.Font.Name = "Verdana"
        prln.Format.Alignment = ParagraphAlignment.Center
        prln.AddLineBreak()




    End Sub
    Private Sub FillTable(ByVal mydt As DataTable, ByVal showHeader As Boolean)


        Me.table = section.AddTable()
        'this.table.Style = "Table";
        Me.table.BottomPadding = "0.1cm"
        Me.table.TopPadding = "0.1cm"
        Me.table.LeftPadding = "0.1cm"
        Me.table.RightPadding = "0.1cm"
        Me.table.Borders.Visible = False
        Me.table.Format.Font.Size = 7
        Me.table.Borders.Width = 0.25
        Me.table.Borders.Left.Width = 0
        Me.table.Borders.Right.Width = 0
        Me.table.Rows.LeftIndent = 0
        Me.table.Columns.Width = "10.0cm"
        Me.table.Format.Font.Name = "Verdana"
        Dim column As Column
        Dim c As Integer = 0
        Dim arr() As String = ColWidth.Split(",")
        Dim arralg() As String = ColAlign.Split(",")
        For Each col As DataColumn In mydt.Columns
            column = Me.table.AddColumn(Unit.FromCentimeter(Convert.ToDouble(arr(c))))
            column.Format.Alignment = Convert.ToInt32(arralg(c))
            c = c + 1
        Next

        If Not showHeader Then
            table.Columns(0).Format.Font.Bold = True
            Try
                'Ver 4.3-FASTFACTS-617 start
                'for displaying the bold in Gross total for PaySlip for Rate
                'table.Columns(2).Format.Font.Bold = True
                If mydt.TableName = "Gross" And table.Columns.Count = 5 Then
                    table.Columns(3).Format.Font.Bold = True
                Else
                    table.Columns(2).Format.Font.Bold = True
                End If
                'Ver 4.3-FASTFACTS-617 end 

            Catch ex As Exception
            End Try
        End If

        Dim row As Row
        Dim row1 As Row
        If showHeader Then
            row = table.AddRow()
            row.Shading.Color = Colors.Gray
            row.Height = "0.4cm"
            For i As Integer = 0 To mydt.Columns.Count - 1
                If ShowRsSymbol.Contains(mydt.Columns(i).ColumnName) Then
                    Dim pp As Paragraph = row.Cells(i).AddParagraph()
                    Dim img As Image = pp.AddImage(HttpContext.Current.Server.MapPath("IMAGES") & "\rs.png")
                    img.WrapFormat.Style = WrapStyle.None

                    If HttpContext.Current.Session("PageName") = "Payslip" Then
                        pp.AddText("Amount")
                    Else
                        Dim tmp As String = mydt.Columns(i).ColumnName
                        If tmp = "DAmount" Then
                            tmp = "Amount"
                        End If
                        Dim f As FormattedText = pp.AddFormattedText(tmp)
                        f.Subscript = True
                        f.Font.Size = 11
                        f.Superscript = True
                    End If
                Else
                    Dim tmp As String = mydt.Columns(i).ColumnName
                    row.Cells(i).AddParagraph(tmp)
                End If
                row.Cells(i).Format.Font.Bold = True
            Next
        End If


        For i As Integer = 0 To mydt.Rows.Count - 1
            row1 = Me.table.AddRow()
            row1.Height = "0.4cm"
            For j As Integer = 0 To mydt.Columns.Count - 1
                row1.Cells(j).AddParagraph(mydt.Rows(i)(j).ToString())
                row1.Cells(j).Shading.Color = (IIf(i Mod 2 = 1, New Color(224, 224, 244), Colors.White))
            Next
        Next

    End Sub

    Private Sub FillTableInvestmentProof(ByVal mydt As DataTable, ByVal showHeader As Boolean)


        Me.table = section.AddTable()
        'this.table.Style = "Table";
        Me.table.BottomPadding = "0.1cm"
        Me.table.TopPadding = "0.1cm"
        Me.table.LeftPadding = "0.1cm"
        Me.table.RightPadding = "0.1cm"
        Me.table.Borders.Visible = True


        Me.table.Borders.Left.Visible = True
        Me.table.Borders.Right.Visible = True
        Me.table.Borders.Left.Visible = True
        Me.table.Borders.Top.Visible = True
        Me.table.Borders.Bottom.Visible = True





        Me.table.Format.Font.Size = 7
        Me.table.Borders.Width = 0.5
        Me.table.Borders.Left.Width = 0.5
        Me.table.Borders.Right.Width = 0.5
        Me.table.Rows.LeftIndent = 0
        Me.table.Columns.Width = "15.0cm"
        Me.table.Format.Font.Name = "Verdana"
        Dim column As Column
        Dim c As Integer = 0
        Dim arr() As String = ColWidth.Split(",")
        Dim arralg() As String = ColAlign.Split(",")
        For Each col As DataColumn In mydt.Columns
            column = Me.table.AddColumn(Unit.FromCentimeter(Convert.ToDouble(arr(c))))
            column.Format.Alignment = Convert.ToInt32(arralg(c))
            c = c + 1
        Next

        If Not showHeader Then
            table.Columns(0).Format.Font.Bold = True
            Try
                table.Columns(2).Format.Font.Bold = True
            Catch ex As Exception
            End Try
        End If

        Dim row As Row
        Dim row1 As Row
        If showHeader Then
            row = table.AddRow()
            row.Shading.Color = Colors.White

            row.Height = "0.4cm"
            For i As Integer = 0 To mydt.Columns.Count - 1
                If ShowRsSymbol.Contains(mydt.Columns(i).ColumnName) Then
                    Dim pp As Paragraph = row.Cells(i).AddParagraph()
                    Dim img As Image = pp.AddImage(HttpContext.Current.Server.MapPath("IMAGES") & "\rs.png")
                    img.WrapFormat.Style = WrapStyle.None

                    If HttpContext.Current.Session("PageName") = "Payslip" Then
                        pp.AddText("Amount")
                    Else
                        Dim tmp As String = mydt.Columns(i).ColumnName
                        If tmp = "DAmount" Then
                            tmp = "Amount"
                        End If
                        Dim f As FormattedText = pp.AddFormattedText(tmp)
                        f.Subscript = True
                        f.Font.Size = 11
                        f.Superscript = True
                    End If
                Else
                    Dim tmp As String = mydt.Columns(i).ColumnName
                    row.Cells(i).AddParagraph(tmp)
                    If (mydt.TableName = "Table2") Then
                        row.Cells(i).Format.Alignment = ParagraphAlignment.Center
                    End If

                End If
                row.Cells(i).Format.Font.Bold = True



            Next

        End If


        For i As Integer = 0 To mydt.Rows.Count - 1
            row1 = Me.table.AddRow()
            row1.Height = "0.4cm"



            For j As Integer = 0 To mydt.Columns.Count - 1
                Dim ii As Integer = 0
                Dim s As String = (mydt.Rows(i)(j).ToString())

                Dim result As Boolean = Integer.TryParse(s, ii)

                If (mydt.Rows(i)(j).ToString() = "House Rent Allowance" Or mydt.Rows(i)(j).ToString() = "Leave travel concessions or assistance (LTA)" Or mydt.Rows(i)(j).ToString() = "1") Then
                    row1.Format.Font.Bold = True



                End If


                row1.Cells(j).Shading.Color = Colors.White
                If (result) Then
                    Dim pp As Paragraph = row1.Cells(j).AddParagraph()
                    Dim f As FormattedText = pp.AddFormattedText(mydt.Rows(i)(j).ToString())
                    pp.Format.Alignment = ParagraphAlignment.Right
                    If (i = 1 And (mydt.TableName = "Table2")) Then

                        pp.Format.Alignment = ParagraphAlignment.Left

                    End If


                Else
                    If (i = 0 And (mydt.TableName = "Table2")) Then
                        Dim pp As Paragraph = row1.Cells(j).AddParagraph()
                        Dim f As FormattedText = pp.AddFormattedText(mydt.Rows(i)(j).ToString())
                        pp.Format.Alignment = ParagraphAlignment.Center

                    Else
                        row1.Cells(j).AddParagraph(mydt.Rows(i)(j).ToString())
                    End If



                End If



                If (i = mydt.Rows.Count - 1) Then
                    row1.Cells(j).Borders.Bottom.Width = 0.25
                    row1.Cells(j).Borders.Left.Width = 0.25
                    row1.Cells(j).Borders.Right.Width = 0.25
                    row1.Cells(j).Borders.Top.Width = 0
                    row1.Cells(j).Borders.Color = Colors.Black
                Else
                    row1.Cells(j).Borders.Width = 0

                End If
                If (i = 0 And (mydt.TableName = "Footer" Or mydt.TableName = "Employee" Or mydt.TableName = "Table2")) Then
                    If (mydt.TableName = "Table2") Then
                        row1.Cells(j).Borders.Bottom.Width = 0.25
                        row1.Cells(j).Borders.Left.Width = 0.25
                        row1.Cells(j).Borders.Right.Width = 0.25
                        row1.Cells(j).Borders.Top.Width = 0.25
                        row1.Cells(j).Borders.Color = Colors.Black
                    Else
                        row1.Cells(j).Borders.Bottom.Width = 0
                        row1.Cells(j).Borders.Left.Width = 0.25
                        row1.Cells(j).Borders.Right.Width = 0.25
                        row1.Cells(j).Borders.Top.Width = 0.25
                        row1.Cells(j).Borders.Color = Colors.Black
                    End If




                End If

            Next
        Next

    End Sub
    Public Sub addline(ByVal strTopMargin As String, ByVal strBottomMargin As String)
        Dim t As New TextFrame()
        t.Height = strTopMargin
        Me.table.Section.Add(t)
        t.AddParagraph().AddText("________________________________________________________________________")
        t = New TextFrame()
        t.Height = strBottomMargin
        Me.table.Section.Add(t)
    End Sub
    Public Sub addline(ByVal len As Integer)
        Dim sb As New StringBuilder()
        Dim i As Integer = 0
        For i = 0 To len
            sb.Append("________")
        Next
        Dim t As New TextFrame()
        t.Height = "0.2cm"
        Me.table.Section.Add(t)
        If Not len = 0 Then
            t.AddParagraph().AddText(sb.ToString())
        End If

        t = New TextFrame()
        t.Height = "0.3cm"
        Me.table.Section.Add(t)
    End Sub
    Shared ReadOnly TableBorder As New Color(81, 125, 192)
    Shared ReadOnly TableBlue As New Color(235, 240, 249)
    Shared ReadOnly TableGray As New Color(242, 242, 242)

End Class